local chatInputActive = false
local chatInputActivating = false

RegisterNetEvent('chatMessage')
RegisterNetEvent('chat:addTemplate')
RegisterNetEvent('chat:addMessage')
RegisterNetEvent('chat:addSuggestion')
RegisterNetEvent('chat:removeSuggestion')
RegisterNetEvent('chat:clear')

-- internal events
RegisterNetEvent('__cfx_internal:serverPrint')

RegisterNetEvent('_chat:muitzaqmessageEntered')

--deprecated, use chat:addMessage
AddEventHandler('chatMessage', function(author, color, text)
  local args = { text }
  if author ~= "" then
    table.insert(args, 1, author)
  end
  SendNUIMessage({
    type = 'ON_MESSAGE',
    message = {
      color = color,
      multiline = true,
      args = args
    }
  })
end)

AddEventHandler('__cfx_internal:serverPrint', function(msg)
  print(msg)

  SendNUIMessage({
    type = 'ON_MESSAGE',
    message = {
      color = { 0, 0, 0 },
      multiline = true,
      args = { msg }
    }
  })
end)

AddEventHandler('chat:addMessage', function(message)
  SendNUIMessage({
    type = 'ON_MESSAGE',
    message = message
  })
end)

AddEventHandler('chat:addSuggestion', onSuggestionAdd)
exports("addSuggestion", onSuggestionAdd)

AddEventHandler('chat:removeSuggestion', function(name)
  SendNUIMessage({
      type = 'ON_SUGGESTION_REMOVE',
      name = name
  })
  if sugesstions[name] then
      sugesstions[name] = nil
  end
end)

AddEventHandler('chat:addTemplate', function(id, html)
  SendNUIMessage({
      type = 'ON_TEMPLATE_ADD',
      template = {
          id = id,
          html = html
      }
  })
end)

AddEventHandler('chat:clear', function(name)
  SendNUIMessage({
      type = 'ON_CLEAR'
  })
end)

RegisterCommand("disable", function(source, args)
  TriggerServerEvent("disableChat", source)
end, false)

spamDetection = 0
spamDetected = 0

RegisterNUICallback('chatResult', function(data, cb)
    chatInputActive = false
    SetNuiFocus(false)
    
    if not data.canceled then
        local id = PlayerId()
        
        --deprecated
        local r, g, b = 0, 0x99, 255
        
        if data.message:sub(1, 1) == '/' then
            ExecuteCommand(data.message:sub(2))
        else
            TriggerServerEvent('_chat:muitzaqmessageEntered', GetPlayerName(id), {r, g, b}, data.message)
        end
    end
    cb('ok')
end)

Citizen.CreateThread(function()
	while true do
		Wait(3000)
		if(spamDetection > 0)then
			spamDetection = 0
		end
	end
end)

Citizen.CreateThread(function()
	while true do
		Wait(9000)
		if(spamDetected == 5)then
			spamDetection = 0
		end
	end
end)

RegisterCommand('+chat', function()
  SetTextChatEnabled(false)
  SetNuiFocus(false)

  chatInputActive = true
  chatInputActivating = true

  SendNUIMessage({type = 'ON_OPEN'})
  SetNuiFocus(true)
end)

RegisterKeyMapping('+chat', 'chat', 'keyboard', 'T')

checkTime = 30 --Minutes
deleteTime = 15 --Seconds

local enumerator = {
	__gc = function(enum)
		if enum.destructor and enum.handle then
			enum.destructor(enum.handle)
		end
		enum.destructor = nil
		enum.handle = nil
	end
}

local function getEntities(initFunc, moveFunc, disposeFunc)
	return coroutine.wrap(function()
		local iter, id = initFunc()
		if not id or id == 0 then
			disposeFunc(iter)
			return
		end
    
		local enum = {handle = iter, destructor = disposeFunc}
		setmetatable(enum, enumerator)
    
		local next = true
		repeat
		coroutine.yield(id)
		next, id = moveFunc(iter)
		until not next
  
		enum.destructor, enum.handle = nil, nil
		disposeFunc(iter)
	end)
end

function getVehicles()
  return getEntities(FindFirstVehicle, FindNextVehicle, EndFindVehicle)
end

RegisterNetEvent("alex:delAllVehs")
AddEventHandler("alex:delAllVehs", function(sec) deleteAllVehs(sec) end)

function deleteAllVehs(theTime)
	local stuff = "^4[INFO]^0 Toate masinile neocupate o sa fie sterse in : "..theTime.." secunde"
	TriggerEvent("chatMessage", "^4[INFO]", {227, 9, 9}, "Toate vehiculele neocupate vor fi sterse in "..theTime.." secunde!")
	SetTimeout(theTime * 1000, function()
		theVehicles = getVehicles()
		local stuff = "^4[INFO]^0 Toate masinile neocupate au fost sterse !"
		for entity in theVehicles do
			local veh = entity
			if DoesEntityExist(veh) then 
				if GetEntityModel(veh) ~= GetHashKey("rcbandito") then
					if not IsEntityAttached(veh) then
						if((GetPedInVehicleSeat(veh, -1)) == false) or ((GetPedInVehicleSeat(veh, -1)) == nil) or ((GetPedInVehicleSeat(veh, -1)) == 0)then
			    			Citizen.InvokeNative( 0xEA386986E786A54F, Citizen.PointerValueIntInitialized( veh ) )
			    
			    			if (DoesEntityExist(veh)) then 
			        			DeleteEntity(veh)
			    			end 
						end
					end
				end
			end
		end
	end)
end











Keys = {
  ['ESC'] = 322, ['F1'] = 288, ['F2'] = 289, ['F3'] = 170, ['F5'] = 166, ['F6'] = 167, ['F7'] = 168, ['F8'] = 169, ['F9'] = 56, ['F10'] = 57,
  ['~'] = 243, ['1'] = 157, ['2'] = 158, ['3'] = 160, ['4'] = 164, ['5'] = 165, ['6'] = 159, ['7'] = 161, ['8'] = 162, ['9'] = 163, ['-'] = 84, ['='] = 83, ['BACKSPACE'] = 177,
  ['TAB'] = 37, ['Q'] = 44, ['W'] = 32, ['E'] = 38, ['R'] = 45, ['T'] = 245, ['Y'] = 246, ['U'] = 303, ['P'] = 199, ['['] = 39, [']'] = 40, ['ENTER'] = 18,
  ['CAPS'] = 137, ['A'] = 34, ['S'] = 8, ['D'] = 9, ['F'] = 23, ['G'] = 47, ['H'] = 74, ['K'] = 311, ['L'] = 182,
  ['LEFTSHIFT'] = 21, ['Z'] = 20, ['X'] = 73, ['C'] = 26, ['V'] = 0, ['B'] = 29, ['N'] = 249, ['M'] = 244, [','] = 82, ['.'] = 81,
  ['LEFTCTRL'] = 36, ['LEFTALT'] = 19, ['SPACE'] = 22, ['RIGHTCTRL'] = 70,
  ['HOME'] = 213, ['PAGEUP'] = 10, ['PAGEDOWN'] = 11, ['DELETE'] = 178,
  ['LEFT'] = 174, ['RIGHT'] = 175, ['TOP'] = 27, ['DOWN'] = 173,
}

DrawText3D = function(x, y, z, text)
	SetTextScale(0.35, 0.35)
    SetTextFont(4)
    SetTextProportional(1)
    SetTextColour(255, 255, 255, 215)
    SetTextEntry("STRING")
    SetTextCentre(true)
    AddTextComponentString(text)
    SetDrawOrigin(x,y,z, 0)
    DrawText(0.0, 0.0)
    local factor = (string.len(text)) / 370
    --DrawRect(0.0, 0.0+0.0125, 0.017+ factor, 0.03, 0, 0, 0, 75)
    ClearDrawOrigin()
end


RegisterNetEvent("repair:kit")
AddEventHandler("repair:kit",function()
    local biSleep = 500
    local finished = false local started = false local cando = true
      while cando do
        local pedcoords = GetEntityCoords(PlayerPedId())
        local vehicle = GetClosestVehicle(pedcoords.x,pedcoords.y,pedcoords.z, 10.0, 0, 70)
        if vehicle ~= 0 then
        local bonnetcoords = GetWorldPositionOfEntityBone(vehicle, GetEntityBoneIndexByName(vehicle, 'bumper_f'))
        local vehheading = GetEntityHeading(vehicle)
        local vehcoords = GetEntityCoords(vehicle)
        local distance = #(vector3(pedcoords.x, pedcoords.y, pedcoords.z) - vector3(vehcoords.x, vehcoords.y, vehcoords.z))
        if (distance) < 3.0 then
          biSleep = 1
          DrawText3D(bonnetcoords.x, bonnetcoords.y, bonnetcoords.z+0.5, '[E] pentru a repara masina')
          if IsControlJustPressed(0, Keys["E"]) and not started then
            started = true
            if started then
              print("started")
              started = false
              SetVehicleDoorOpen(vehicle, 4, true, true)
              SetEntityHeading(PlayerPedId(), vehheading+180)
              SetVehicleUndriveable(vehicle, true)
              FreezeEntityPosition(PlayerPedId(), true)
              ExecuteCommand("e mechanic")
              Wait(5000) -- daca vrei pui progress bar
              ExecuteCommand("e c")
              finished = true
            end
          end
        end
        if finished then
          print("finished")
          SetVehicleUndriveable(vehicle, false)
          SetVehicleDoorShut(vehicle, 4, true, true)
          FreezeEntityPosition(PlayerPedId(), false)
          SetVehicleBodyHealth(vehicle, 9999)
          SetVehicleEngineHealth(vehicle, 9999)
          SetVehiclePetrolTankHealth(vehicle, 9999)
          SetVehicleFixed(vehicle)
          finished = false
          cando=false
          vehicle = 0
          --notificare ca ai reparat cu sucess
        end
      else
        --notificare ca nu exista masina in jur
      end
      Citizen.Wait(biSleep)
    end
end)

SetTimeout(msec, callback)